//xsetaseta@gmail.com
//
//LTC6904 con arduino 1.8.5
//2020

/*
  I2C SDA (data line) = analog pin 4  ->CHIP SDI-pin2
  I2C SDC (clock line) = analog pin 5 ->CHIP SCK-pin3
  Resistencias de 1K a Vcc
*/

//#define MODO_SETA 

#include <Wire.h>
#define LTC6904_ADDRESS 22  // CHIP pin ADR(4)<-VCC


#include "LedControl.h"
/*
 Now we need a LedControl to work with.
 ***** These pin numbers will probably not work with your hardware *****
 pin 12 is connected to the DataIn 
 pin 11 is connected to the CLK 
 pin 10 is connected to LOAD 
 We have only a single MAX72XX.
 */
LedControl lc=LedControl(12,11,10,1);




byte display[8];
char segmento=0;
char cadena[20];

int frecu1=0;
int frecu0=0;
long frecux=0;
 float frecuxf;

char parpadeo=4;




void setFreqSETA(long freq) //HZ
{
 int z;
 long frecu;
 long mipo;
 unsigned int oct;

    frecu=freq;
    for(z=0;z<16;z++)
      {      
        if(frecu>1038 && frecu<2078) break;
        frecu/=2;
      }

  oct =z;
  mipo=2;
  for(z=1;z<oct+10;z++)    mipo*=2;

  unsigned int dac =  2048 - (2078 *mipo) / freq;
  Serial.print(oct); Serial.print("<-oct SETA  dac->");Serial.println(dac);
      
  unsigned int reg = oct << 12 | dac << 2 ;
   
  byte high = (reg >> 8) & 0xff;
  byte low = reg & 0xff;
   
  Wire.beginTransmission(LTC6904_ADDRESS);
  Wire.write(high);
  Wire.write(low);
  Wire.endTransmission();  
}
 


void setFreq(float freq, boolean compOutputOn=true) 
{
  unsigned int oct = (int) (3.322*log10(freq * 1000.0 / 1039.0));
  unsigned int dac = (int) (2048.0 - 2078.0 * pow(2, 10 + oct) / (freq * 1000.0) + 0.5);

  Serial.print(oct); Serial.print("<-oct X dac->");Serial.println(dac);
     
  unsigned int cnf = compOutputOn ? 0 : 2; 
  unsigned int reg = oct << 12 | dac << 2 | cnf;
   
  byte high = (reg >> 8) & 0xff;
  byte low = reg & 0xff;
   
  Wire.beginTransmission(LTC6904_ADDRESS);
  Wire.write(high);
  Wire.write(low);
  Wire.endTransmission();  
}





void printDisplayN(long z,char parpadeo=-1)
{
  sprintf(cadena,"%08li",z);
    lc.setChar(0,7,cadena[0],false);
    lc.setChar(0,6,cadena[1],false);
    lc.setChar(0,5,cadena[2],false);
    lc.setChar(0,4,cadena[3],false);
    lc.setChar(0,3,cadena[4],false);
    lc.setChar(0,2,cadena[5],false);
    lc.setChar(0,1,cadena[6],false);
    lc.setChar(0,0,cadena[7],false);
  
  if(parpadeo>=0)
  {
    switch(segmento)
      {
        case 7:
          lc.setChar(0,7,cadena[0],true);
        break;
        case 6:
          lc.setChar(0,6,cadena[1],true);
        break;
        case 5:
          lc.setChar(0,5,cadena[2],true);
        break;
        case 4:
          lc.setChar(0,4,cadena[3],true);
        break;

        case 3:
          lc.setChar(0,3,cadena[4],true);
        break;
        case 2:
          lc.setChar(0,2,cadena[5],true);
        break;
        case 1:
          lc.setChar(0,1,cadena[6],true);
        break;
        case 0:
          lc.setChar(0,0,cadena[7],true);
        break;
      }
  }
  
}

void setup() 
{
  Serial.begin(9600);

  pinMode(3,INPUT_PULLUP);
  digitalWrite(3,HIGH);
  pinMode(6,INPUT_PULLUP);
  digitalWrite(6,HIGH);
  

  Wire.begin(); // We're I2C-Bus Master

  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,1);
  /* and clear the display */
  lc.clearDisplay(0);

  Serial.println("INICIO");

  printDisplayN(frecux);
}

void loop() 
{

  if(digitalRead(3) == LOW)
  {
    parpadeo=10;
    segmento++;
    if (segmento>7)segmento=0;
  }

  if(digitalRead(6) == LOW)
  {    
      switch(segmento)
      {
       case 7:
          display[0]++; if(display[0]>9) display[0]=0;
       break; 
       case 6:
          display[1]++; if(display[1]>9) display[1]=0;
       break; 
       case 5:
          display[2]++; if(display[2]>9) display[2]=0;
       break; 
       case 4:
          display[3]++; if(display[3]>9) display[3]=0;
       break; 
       case 3:
          display[4]++; if(display[4]>9) display[4]=0;
       break; 
       case 2:
          display[5]++; if(display[5]>9) display[5]=0;
       break; 
       case 1:
          display[6]++; if(display[6]>9) display[6]=0;
       break; 
       case 0:
          display[7]++; if(display[7]>9) display[7]=0;
       break; 
      }

      frecu1=display[0]*1000+display[1]*100+display[2]*10+display[3];  
      frecu0=display[4]*1000+display[5]*100+display[6]*10+display[7];
       
      frecux=(long)frecu1*10000 +frecu0;
      printDisplayN(frecux);   
      parpadeo=10;
  }




  if(parpadeo<2)
    {
      if(parpadeo==1)
        {

          if(frecux<1039)
            {
              frecux=1039;
              display[4]=1;  display[5]=0; display[6]=3;  display[7]=9;
              display[0]=0;  display[1]=0; display[2]=0;  display[3]=0;
              printDisplayN(frecux);
            }

          if(frecux>68000000)
            {
              frecux=68000000;
              display[4]=0;  display[5]=0; display[6]=0;  display[7]=0;
              display[0]=6;  display[1]=8; display[2]=0;  display[3]=0;
              printDisplayN(frecux);
            }

          parpadeo=0;
          frecuxf=frecux;
          frecuxf/=1000;
#ifdef MODO_SETA                  
          setFreqSETA(frecux);
#else
          setFreq(frecuxf);
#endif           
          Serial.print("FRECUENCIA="); Serial.println(frecux);
        }
    }
  else
    {
      parpadeo--;
      delay(100);
      printDisplayN(frecux,segmento);
      delay(100);      
      printDisplayN(frecux);
    }
  
}
